// RayTri.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>


/*
 
* Parse input file

< new ITriangleTextParser />

< %.Parse input="triangle file name" output="triangle vertex data" />
         
< new IRayTextParser />

< %.Parse input="ray file name", output="ray data" />

< new ITriangleInstanceBuilder input="triangle data" />

< new IRayInstanceBuilder input="triangle data" />

* Decide the strategy
< new ItersectionFactory 
      input="ITriangleInstanceBuilder, IRayInstanceBuilder, argument list" />
  
< %.Create output="IIntersect" />

  <| accelerate : new BSPTriangleInstanceBuilder, input="ITriangleInstanceBuilder" |>
  < ITriangleInstanceBuilder.CreateTriangleList output="triangle list"/>
    [ BSPTriangleInstanceBuilder.CreateTriangleList /]
  

  < new IIntersection />
    [ new LinearIntersection/]

    [ new ConcurrentIntersection/]  

* Intersection test
< IIntersect.Calculate, output="point data" />
    [ LinearIntersection.Calculate, output="point data" /]
    [ ConcurrentIntersection.Calculate, output="point data" /]

*/
    
                       

int main(int argc, char* argv[])
{
    return 0;
}
